"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TwitterOpenApiClient = exports.TwitterOpenApi = void 0;
var apis_1 = require("./apis");
var i = require("twitter-gengar-generated");
var usersApi_1 = require("./apis/usersApi");
var TwitterOpenApi = /** @class */ (function () {
    function TwitterOpenApi() {
        this.initOverrides = {};
    }
    TwitterOpenApi.prototype.get_browser_headers = function () {
        return __awaiter(this, void 0, void 0, function () {
            var raw, json, ignore, keys;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, _a.fetchApi(_a.header)];
                    case 1:
                        raw = _b.sent();
                        return [4 /*yield*/, raw.json()];
                    case 2:
                        json = _b.sent();
                        ignore = ["host", "connection"];
                        keys = Object.keys(json["chrome-fetch"]).filter(function (key) { return !ignore.includes(key); });
                        return [2 /*return*/, __assign(__assign({}, keys.reduce(function (a, b) {
                                var _b;
                                return (__assign(__assign({}, a), (_b = {}, _b[b] = json["chrome-fetch"][b], _b)));
                            }, {})), { 'accept-encoding': 'identity', "priority": "u=1, i", "referer": "https://twitter.com/home" })];
                }
            });
        });
    };
    TwitterOpenApi.prototype.get_api_key = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.get_browser_headers()];
                    case 1:
                        data = _b.sent();
                        return [2 /*return*/, __assign(__assign({}, data), { 'x-twitter-client-language': 'en', 'x-twitter-active-user': 'yes', authorization: "Bearer ".concat(_a.bearer) })];
                }
            });
        });
    };
    TwitterOpenApi.prototype.setInitOverrides = function (initOverrides) {
        this.initOverrides = initOverrides;
    };
    TwitterOpenApi.prototype.cookie_normalize = function (cookie) {
        return cookie.reduce(function (a, b) {
            var _b;
            var _c = __read(b.split('; ')[0].split('='), 2), key = _c[0], value = _c[1];
            return __assign(__assign({}, a), (_b = {}, _b[key] = value, _b));
        }, {});
    };
    TwitterOpenApi.prototype.cookieEncode = function (cookie) {
        return Object.entries(cookie)
            .map(function (_b) {
            var _c = __read(_b, 2), key = _c[0], value = _c[1];
            return "".concat(key, "=").concat(value);
        })
            .join('; ');
    };
    TwitterOpenApi.prototype.setCookies = function (context, cookies) {
        if (context.init.headers) {
            var headers = context.init.headers;
            headers['cookie'] = this.cookieEncode(cookies);
        }
        return context;
    };
    TwitterOpenApi.prototype.getGuestClient = function () {
        return __awaiter(this, void 0, void 0, function () {
            var cookies, response, html, re, find, activate_headers, guest_token;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        cookies = {};
                        return [4 /*yield*/, _a.fetchApi(_a.twitter, __assign({ method: 'GET', redirect: 'manual', headers: { Cookie: this.cookieEncode(cookies) } }, this.initOverrides))];
                    case 1:
                        response = _c.sent();
                        if (response.headers.getSetCookie) {
                            cookies = __assign(__assign({}, cookies), this.cookie_normalize(response.headers.getSetCookie()));
                        }
                        else {
                            cookies = __assign(__assign({}, cookies), this.cookie_normalize(((_b = response.headers.get('set-cookie')) === null || _b === void 0 ? void 0 : _b.split(', ')) || []));
                        }
                        return [4 /*yield*/, response.text()];
                    case 2:
                        html = _c.sent();
                        re = new RegExp('document.cookie="(.*?)";', 'g');
                        find = __spreadArray([], __read(html.matchAll(re)), false).map(function (e) { return e[1]; });
                        cookies = __assign(__assign({}, cookies), this.cookie_normalize(find));
                        cookies = Object.entries(cookies)
                            .filter(function (_b) {
                            var _c = __read(_b, 2), key = _c[0], value = _c[1];
                            return key != 'ct0';
                        })
                            .reduce(function (a, _b) {
                            var _c;
                            var _d = __read(_b, 2), key = _d[0], value = _d[1];
                            return (__assign(__assign({}, a), (_c = {}, _c[key] = value, _c)));
                        }, {});
                        if (!!cookies['gt']) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.get_api_key()];
                    case 3:
                        activate_headers = _c.sent();
                        return [4 /*yield*/, _a.fetchApi('https://api.twitter.com/1.1/guest/activate.json', __assign({ method: 'POST', headers: activate_headers }, this.initOverrides)).then(function (response) { return response.json(); })];
                    case 4:
                        guest_token = (_c.sent()).guest_token;
                        cookies['gt'] = guest_token;
                        _c.label = 5;
                    case 5: 
                    // const chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'];
                    // const csrfToken = [...Array(32)].reduce((a) => a + chars[Math.floor(Math.random() * chars.length)], '');
                    // cookies.push({ name: 'ct0', value: csrfToken });
                    return [2 /*return*/, this.getClientFromCookies(cookies)];
                }
            });
        });
    };
    TwitterOpenApi.prototype.getClientFromCookies = function (cookies) {
        return __awaiter(this, void 0, void 0, function () {
            var api_key, config;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.get_api_key()];
                    case 1:
                        api_key = _b.sent();
                        if (cookies['ct0']) {
                            api_key['x-twitter-auth-type'] = 'OAuth2Session';
                            api_key['x-csrf-token'] = cookies['ct0'];
                        }
                        if (cookies['gt']) {
                            api_key['x-guest-token'] = cookies['gt'];
                        }
                        config = {
                            fetchApi: _a.fetchApi,
                            middleware: [{ pre: function (context) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_b) {
                                        return [2 /*return*/, this.setCookies(context, cookies)];
                                    }); }); } }],
                            apiKey: function (key) { return api_key[key.toLowerCase()]; },
                            accessToken: _a.bearer,
                        };
                        return [2 /*return*/, this.getClient(new i.Configuration(config))];
                }
            });
        });
    };
    TwitterOpenApi.prototype.getClient = function (api) {
        return __awaiter(this, void 0, void 0, function () {
            var flag;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, _a.fetchApi(_a.url, __assign({ method: 'GET' }, this.initOverrides)).then(function (res) { return res.json(); })];
                    case 1:
                        flag = (_b.sent());
                        return [2 /*return*/, new TwitterOpenApiClient(api, flag, this.initOverrides)];
                }
            });
        });
    };
    var _a;
    _a = TwitterOpenApi;
    TwitterOpenApi.hash = 'fbfe847e9b3f11e2b25e294827f3637e316d41f0';
    TwitterOpenApi.url = "https://raw.githubusercontent.com/fa0311/twitter-openapi/".concat(_a.hash, "/src/config/placeholder.json");
    TwitterOpenApi.header = "https://raw.githubusercontent.com/fa0311/latest-user-agent/main/header.json";
    TwitterOpenApi.twitter = 'https://twitter.com/home';
    TwitterOpenApi.bearer = 'AAAAAAAAAAAAAAAAAAAAANRILgAAAAAAnNwIzUejRCOuH5E6I8xnZz4puTs%3D1Zv7ttfk8LF81IUq16cHjhLTvJu4FA33AGWWjCpTnA';
    TwitterOpenApi.fetchApi = fetch.bind(globalThis);
    return TwitterOpenApi;
}());
exports.TwitterOpenApi = TwitterOpenApi;
var TwitterOpenApiClient = /** @class */ (function () {
    function TwitterOpenApiClient(config, flag, initOverrides) {
        this.config = config;
        this.flag = flag;
        this.initOverrides = initOverrides;
    }
    TwitterOpenApiClient.prototype.getDefaultApi = function () {
        return new apis_1.DefaultApiUtils(new i.DefaultApi(this.config), this.flag, this.initOverrides);
    };
    TwitterOpenApiClient.prototype.getTweetApi = function () {
        return new apis_1.TweetApiUtils(new i.TweetApi(this.config), this.flag, this.initOverrides);
    };
    TwitterOpenApiClient.prototype.getUserApi = function () {
        return new apis_1.UserApiUtils(new i.UserApi(this.config), this.flag, this.initOverrides);
    };
    TwitterOpenApiClient.prototype.getUsersApi = function () {
        return new usersApi_1.UsersApiUtils(new i.UsersApi(this.config), this.flag, this.initOverrides);
    };
    TwitterOpenApiClient.prototype.getUserListApi = function () {
        return new apis_1.UserListApiUtils(new i.UserListApi(this.config), this.flag, this.initOverrides);
    };
    TwitterOpenApiClient.prototype.getPostApi = function () {
        return new apis_1.PostApiUtils(new i.PostApi(this.config), this.flag, this.initOverrides);
    };
    TwitterOpenApiClient.prototype.getV11GetApi = function () {
        return new apis_1.V11GetApiUtils(new i.V11GetApi(this.config), this.flag, this.initOverrides);
    };
    TwitterOpenApiClient.prototype.getV11PostApi = function () {
        return new apis_1.V11PostApiUtils(new i.V11PostApi(this.config), this.flag, this.initOverrides);
    };
    TwitterOpenApiClient.prototype.getV20GetApi = function () {
        return new apis_1.V20GetApiUtils(new i.V20GetApi(this.config), this.flag, this.initOverrides);
    };
    TwitterOpenApiClient.prototype.getInitialStateApi = function () {
        return new apis_1.InitialStateApiUtils();
    };
    return TwitterOpenApiClient;
}());
exports.TwitterOpenApiClient = TwitterOpenApiClient;
//# sourceMappingURL=api.js.map