import { DefaultFlag, RequestParam, TwitterApiUtilsResponse, UserApiUtilsData, initOverrides } from '../models';
import * as i from 'twitter-gengar-generated';
type getUserByScreenNameParam = {
    screenName: string;
    extraParam?: {
        [key: string]: any;
    };
};
type getUserByRestIdParam = {
    userId: string;
    extraParam?: {
        [key: string]: any;
    };
};
type ResponseType = TwitterApiUtilsResponse<UserApiUtilsData>;
export declare class UserApiUtils {
    api: i.UserApi;
    flag: DefaultFlag;
    initOverrides: initOverrides;
    constructor(api: i.UserApi, flag: DefaultFlag, initOverrides: initOverrides);
    request<T>(param: RequestParam<i.UserResults, T>): Promise<ResponseType>;
    getUserByScreenName(param: getUserByScreenNameParam): Promise<ResponseType>;
    getUserByRestId(param: getUserByRestIdParam): Promise<ResponseType>;
}
export {};
//# sourceMappingURL=userApi.d.ts.map