import { DefaultFlag, RequestParam, TwitterApiUtilsResponse, UserApiUtilsData, initOverrides } from '../models';
import * as i from 'twitter-gengar-generated';
type getUsersByRestIdsParam = {
    userIds: string[];
    extraParam?: {
        [key: string]: any;
    };
};
type ResponseType = TwitterApiUtilsResponse<UserApiUtilsData[]>;
export declare class UsersApiUtils {
    api: i.UsersApi;
    flag: DefaultFlag;
    initOverrides: initOverrides;
    constructor(api: i.UsersApi, flag: DefaultFlag, initOverrides: initOverrides);
    request<T>(param: RequestParam<i.UserResults[], T>): Promise<ResponseType>;
    getUsersByRestIds(param: getUsersByRestIdsParam): Promise<ResponseType>;
}
export {};
//# sourceMappingURL=usersApi.d.ts.map