import { DefaultFlag, RequestParam, TweetApiUtilsData, TwitterApiUtilsResponse, initOverrides } from '../models';
import * as i from 'twitter-gengar-generated';
export type ProfileSpotlightsQueryParam = {
    screenName: string;
    extraParam?: {
        [key: string]: any;
    };
};
export type TweetResultByRestIdParam = {
    tweetId: string;
    extraParam?: {
        [key: string]: any;
    };
};
export declare class DefaultApiUtils {
    api: i.DefaultApi;
    flag: DefaultFlag;
    initOverrides: initOverrides;
    constructor(api: i.DefaultApi, flag: DefaultFlag, initOverrides: initOverrides);
    request<T1, T2>(param: RequestParam<T1, T2>): Promise<TwitterApiUtilsResponse<T1>>;
    getProfileSpotlightsQuery(param: ProfileSpotlightsQueryParam): Promise<TwitterApiUtilsResponse<i.UserResultByScreenName>>;
    getTweetResultByRestId(param: TweetResultByRestIdParam): Promise<TwitterApiUtilsResponse<TweetApiUtilsData | undefined>>;
}
//# sourceMappingURL=defaultApi.d.ts.map