import { DefaultFlag, TwitterApiUtilsResponse, initOverrides } from '../models';
import * as i from 'twitter-gengar-generated';
type PostCreateFriendshipsParam = {
    userId: string;
    extraParam?: {
        [key: string]: any;
    };
};
type PostDestroyFriendshipsParam = {
    userId: string;
    extraParam?: {
        [key: string]: any;
    };
};
export declare class V11PostApiUtils {
    api: i.V11PostApi;
    flag: DefaultFlag;
    initOverrides: initOverrides;
    constructor(api: i.V11PostApi, flag: DefaultFlag, initOverrides: initOverrides);
    postCreateFriendships(param: PostCreateFriendshipsParam): Promise<TwitterApiUtilsResponse<undefined>>;
    postDestroyFriendships(param: PostDestroyFriendshipsParam): Promise<TwitterApiUtilsResponse<undefined>>;
}
export {};
//# sourceMappingURL=v11PostApi.d.ts.map