import { TwitterOpenApi } from '@/api';
import { promises as fs } from 'fs';
import * as log4js from 'log4js';

const authToken = 'fc02b9ffb32d51df41cf0d11def0b88d78155c10'
const CsrfToken = 'c175d569c29be8236ba4a2136fe0d68b2bb90df6129c4208aab5e5ec43f90406204442f893f7188c56bcf26315277092d87b264e243f2d18f0193b121323a5334b4f831f2e5f9c855d7f6677697ff235'

export const logger = log4js
  .configure({
    appenders: {
      system: {
        type: 'file',
        filename: 'logs/test.log',
        layout: {
          type: 'pattern',
          pattern: '[%d{hh:mm:ss}] [%p] %m',
        },
      },
    },
    categories: {
      default: { appenders: ['system'], level: 'all' },
    },
  })
  .getLogger('Test');

export type Cookie = {
  name: string;
  domain: string;
  value: string;
};

export const getClient = async () => {
  const api = new TwitterOpenApi();
  const client = await api.getClientFromCookies({
    ct0: CsrfToken,
    auth_token: authToken,
  });
  return client;
};
export const getGuestClient = async () => {
  const api = new TwitterOpenApi();
  const client = await api.getGuestClient();
  return client;
};
